//+------------------------------------------------------------------+
//|                                                      EA_Test.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

  extern int 
      SL_Point        = 15
  ,   Slip            = 3
  ,   MS_Big          = 30
  ,   MS_Small        = 15
  ,   Point_Win       = 50
  ,   mSecond_Sleep   = 110
  ,   Seek_Period_Ind = 16
  ,   Bar_Ignore_Ind  = 3
  ,   Range_Ratio_Ind = 10.5
  ,   Delta_Ratio_Ind = 3
  ;

  int 
      Bars_Sleep
  ,   Pips_Slip
  ,   Pips_Digits
  ,   TP_Point = 0
  ;
  double 
      Pips_SL
  ;
  int init()
  {
    Bars_Sleep = Period()*60;
    if( Digits%2 == 1 ) 
    {
      Pips_SL     = Point*10;
      Pips_Slip   = 10;
      Pips_Digits = 1;
    }
    else 
    {
      Pips_SL     = Point;
      Pips_Slip   = 1;
      Pips_Digits = 0;
    }
    return(0);
  }


  int deinit()
  {
    return(0);
  }

  int start()
  {
    if ( OrderSelect(OrdersHistoryTotal()-1,SELECT_BY_POS,MODE_HISTORY) )
      if (
         (OrderCloseTime()-OrderOpenTime())/Bars_Sleep <= 10  
      &&  OrderProfit()                                <  0     
      && (TimeCurrent()-OrderCloseTime())/Bars_Sleep   <= 2
         )
           return(0);

    Move_Stop_Loss();
    
    int Signal =  iCustom(NULL,0,"Test_Ind",Seek_Period_Ind,Bar_Ignore_Ind,Range_Ratio_Ind,Delta_Ratio_Ind,1,0);
    if( Signal == 0 ) return(0);
    if( OrdersTotal() == 0 )
    {
      if( Signal == 1 ) 
      {
        iWait();
        int Order_Ticket= OrderSend(Symbol(),OP_BUY,1,Ask,Slip*Pips_Slip,Ask-SL_Point*Pips_SL,TP_Point,0,100,0,0); 
        if( Order_Ticket < 0 ) 
        {
          Print("OrderSend() failed: ",GetLastError());
          OrderSend(Symbol(),OP_BUY,1,Ask,Slip*Pips_Slip,Ask-SL_Point*Pips_SL,TP_Point,0,100,0,0);
        }
      }
      else if(Signal==-1)
      {  
        iWait();
        Order_Ticket= OrderSend(Symbol(),OP_SELL,1,Bid,Slip*Pips_Slip,Bid+SL_Point*Pips_SL,TP_Point,0,101,0,0);
        if( Order_Ticket < 0 ) 
        {
          Print("OrderSend() failed: ",GetLastError());
          OrderSend(Symbol(),OP_SELL,1,Bid,Slip*Pips_Slip,Bid+SL_Point*Pips_SL,TP_Point,0,101,0,0);
        }
      }
    }
    else if( OrderSelect(OrdersTotal()-1,SELECT_BY_POS) )
    {
      if( OrderType() == OP_BUY && Signal == -1 ) 
        {
          if( OrderClose(OrderTicket(),1,Bid,Slip*Pips_Slip,0) )  
            Order_Ticket= OrderSend(Symbol(),OP_SELL,1,Bid,Slip*Pips_Slip,Bid+SL_Point*Pips_SL,TP_Point,0,110,0,0);
             if( Order_Ticket < 0 ) 
             {
               Print("OrderSend() failed: ",GetLastError());
               OrderSend(Symbol(),OP_SELL,1,Bid,Slip*Pips_Slip,Bid+SL_Point*Pips_SL,TP_Point,0,110,0,0);
             }
        }
      else if( OrderType() == OP_SELL && Signal == 1 ) 
        {
          if( OrderClose(OrderTicket(),1,Ask,Slip*Pips_Slip,0) )  
            Order_Ticket=OrderSend(Symbol(),OP_BUY,1,Ask,Slip*Pips_Slip,Ask-SL_Point*Pips_SL,TP_Point,0,111,0,0);
            if( Order_Ticket < 0 ) 
             {
               Print("OrderSend() failed: ",GetLastError());
               OrderSend(Symbol(),OP_BUY,1,Ask,Slip*Pips_Slip,Ask-SL_Point*Pips_SL,TP_Point,0,111,0,0);
             }
        }
     }
    return(0);
  }

  void Move_Stop_Loss()             // Stop loss line will go when absolute value of current price minus stop loss price is  
  {                                 // bigger than big stop level, and when order profit grows big, the stop level should 
    int OT =  OrdersTotal();        // be changed to small stop level from the big one.                     
    if( OT == 0 ) return;
      if(OrderSelect(OT-1,SELECT_BY_POS))
      {
        int Profit_Point = NormalizeDouble( MathAbs( OrderClosePrice() - OrderOpenPrice() )/Pips_SL,0 )
        ,   Move_Stop    = MS_Big; 

        if( Profit_Point > Point_Win ) Move_Stop = MS_Small;
        if( OrderType() == OP_BUY && Bid-OrderStopLoss() > Move_Stop*Pips_SL )
        {
          iWait();
          OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Move_Stop*Pips_SL,0,0,0);
        }
        else if( OrderType() == OP_SELL && OrderStopLoss()-Ask > Move_Stop*Pips_SL )
        {
          iWait();
          OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Move_Stop*Pips_SL,0,0,0);
        }
      }
    return;
  }

  void iWait()
  {
    if( IsTradeContextBusy() || !IsTradeAllowed() )
    Sleep(mSecond_Sleep);
    RefreshRates();
    return;
  }

//ֵָKֵò


/* Rather wait/sleep if the order fails and not before, because the bid/ask price my change while you wait.
int Order_Ticket= OrderSend(Symbol(),OP_BUY,1,Ask,3*Pips_Slip,Ask-SL_Point*Pips_SL,TP_Point,0,100,0,0); // most time I don't want to use takeprofit unless some little change(i will define it in future in think so i think no need to give it an extern variable).
        if( Order_Ticket < 0 ) 
        {
          Print("OrderSend() failed: ",GetLastError());
          OrderSend(Symbol(),OP_BUY,1,Ask,3*Pips_Slip,Ask-SL_Point*Pips_SL,TP_Point,0,100,0,0);
        }
 what about OrderClose()? OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Move_Stop*Pips_SL,0,0,0);
 
  MathAbs() will consider a Loss as a Profit ( rather check if order is long or short )
 
 
 */

